.intel_syntax noprefix

.global load_idt
load_idt:
    lidt [rdi]
    ret

.global write_cr3
write_cr3:
    mov cr3, rdi
    ret

.global read_msr
read_msr:
    mov rcx, rdi
    rdmsr
    shl rdx, 32
    or rax, rdx
    ret

.global write_msr
write_msr:
    mov rcx, rdi
    mov rax, rsi
    mov rdx, rax
    shr rdx, 32
    wrmsr
    ret